package cyano.electricadvantage.blocks;

import net.minecraft.block.Block;
import net.minecraft.block.SoundType;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;

import java.util.Random;

public class Ore extends Block {

	private final ItemStack dropItem;
	private final int dropRange;
	
	
	public Ore(ItemStack oreDrop, int pickLevel, int variation){
		super(Material.field_151576_e);
		this.func_149647_a(CreativeTabs.field_78030_b);
		this.func_149711_c(1.5f+pickLevel); // dirt is 0.5, grass is 0.6, stone is 1.5,iron ore is 3, obsidian is 50
		this.func_149752_b(5*(1+pickLevel)); // dirt is 0, iron ore is 5, stone is 10, obsidian is 2000
		this.func_149672_a(SoundType.field_185851_d); // sound for stone
		this.setHarvestLevel("pickaxe", pickLevel);
		dropItem = oreDrop;
		dropRange = variation+1;
	}
	
	public Ore( int pickLevel){
		super(Material.field_151576_e);
		this.func_149647_a(CreativeTabs.field_78030_b);
		this.func_149711_c(1.5f+pickLevel); // dirt is 0.5, grass is 0.6, stone is 1.5,iron ore is 3, obsidian is 50
		this.func_149752_b(5*(1+pickLevel)); // dirt is 0, iron ore is 5, stone is 10, obsidian is 2000
		this.func_149672_a(SoundType.field_185851_d); // sound for stone
		this.setHarvestLevel("pickaxe", pickLevel);
		dropItem = null;
		dropRange = 0;
	}
	
	@Override public Item func_180660_a(IBlockState bs, Random prng, int n)
	{
		if(dropItem == null){
			return super.func_180660_a(bs, prng, n);
		}
		return dropItem.func_77973_b();
	}
	@Override public int func_149745_a(Random prng)
	{
		final int baseCount;
		if(dropItem == null){
			baseCount = 1;
		} else {
			baseCount = dropItem.field_77994_a;
		}
		if(dropRange > 1){
			return baseCount + prng.nextInt(dropRange);
		}
		return baseCount;
	}
}
