package cyano.electricadvantage.blocks;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.Explosion;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

import java.util.Collections;
import java.util.List;
import java.util.Random;

public class PumpPipeBlock extends Block{


	private static final AxisAlignedBB bounds = new AxisAlignedBB(0.25,0.00,0.25,0.75,1.00,0.75);

	public PumpPipeBlock() {
		super(Material.field_151573_f);
		this.func_149711_c(5.0F).func_149752_b(10.0F);
	}

	@Override
	public Item func_180660_a(IBlockState bs, Random rand, int fortune){
		return null;
	}
	
	@Override 
	public int quantityDropped(IBlockState state, int fortune, Random random){
		return 0;
	}
	
	@Override public List<ItemStack> getDrops(IBlockAccess world, BlockPos pos, IBlockState state, int fortune){
		return Collections.EMPTY_LIST;
	}


	//And this tell it that you can see through this block, and neighbor blocks should be rendered.
	@Override
	public boolean func_149662_c(IBlockState bs)
	{
		return false;
	}
	
	@Override
	public boolean func_149686_d(IBlockState bs){
		return false;
	}
	@Override
	public AxisAlignedBB func_185496_a(IBlockState state, IBlockAccess source, BlockPos pos) {
		return bounds;
	}
	@Override
	public void func_185477_a(final IBlockState bs, final World world, final BlockPos coord,
									  final AxisAlignedBB box, final List collisionBoxList,
									  final Entity entity) {
		super.func_185492_a(coord, box, collisionBoxList, bounds);
	}




	@Override
	public void func_176206_d(World w, BlockPos coord, IBlockState state){
		destroyNeighbors(w,coord,w.func_180495_p(coord));
		super.func_176206_d(w, coord, state);
	}

	@Override
	public void func_180652_a(World w, BlockPos coord, Explosion boom){
		destroyNeighbors(w,coord,w.func_180495_p(coord));
		super.func_180652_a(w, coord, boom);
	}

	
	private void destroyNeighbors(World w, BlockPos coord, IBlockState state) {
		if(w.field_72995_K) return;
		// destroy connected drill bits
		BlockPos c = coord.func_177977_b();
		while(c.func_177956_o() > 0 && w.func_180495_p(c).func_177230_c() == this){
			w.func_175698_g(c);
			c = c.func_177977_b();
		}
	}
	
}
