package cyano.electricadvantage.graphics;

import cyano.electricadvantage.ElectricAdvantage;
import cyano.electricadvantage.entities.HydroturbineEntity;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.VertexBuffer;
import net.minecraft.client.renderer.entity.Render;
import net.minecraft.client.renderer.entity.RenderManager;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.entity.Entity;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.math.MathHelper;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

@SideOnly(Side.CLIENT)
public class HydroturbineRenderer extends Render{
	private static final ResourceLocation texture = new ResourceLocation(ElectricAdvantage.MODID+":textures/entity/hydroturbine.png");

	private static final float DEGREES_TO_RADIANS = (float)(Math.PI / 180);

	public HydroturbineRenderer(final RenderManager rm) {
		super(rm);
	}

	@Override
	public void func_76986_a(final Entity entity, final double x, final double y, final double z, final float scale, final float partialTick) {
		if(entity instanceof HydroturbineEntity){
			final float pixel = 1.0f / 16;
			HydroturbineEntity e = (HydroturbineEntity)entity;
			GlStateManager.func_179094_E();
			this.func_180548_c(e);
			GlStateManager.func_179109_b((float)x, (float)y, (float)z);
			GlStateManager.func_179091_B();
			//   final float scale = this.scale;
			//   GlStateManager.scale(scale / 1.0f, scale / 1.0f, scale / 1.0f);
			final Tessellator instance = Tessellator.func_178181_a();
			final VertexBuffer worldRenderer = instance.func_178180_c();
			final float topHeight = 0.5f;
			final float bottomHeight = 0.375f-0.5f;
			final float radius = pixel;
			final float shaftMinU = 0.5f;
			final float shaftMinV = 0.5f;
			final float shaftMaxU = 0.5f+2*pixel;
			final float shaftMaxV = 1.0f;
			
			GlStateManager.func_179109_b(0f, 0.5f, 0f);
			GlStateManager.func_179114_b(e.field_70177_z, 0.0f, 1.0f, 0.0f);
			this.func_110776_a(this.func_110775_a(e));
			worldRenderer.func_181668_a(7, DefaultVertexFormats.field_181707_g);

			// render shaft
			worldRenderer.func_181662_b(+radius, bottomHeight, -radius).func_187315_a(shaftMinU,shaftMinV).func_181675_d();
			worldRenderer.func_181662_b(-radius, bottomHeight, -radius).func_187315_a(shaftMaxU,shaftMinV).func_181675_d();
			worldRenderer.func_181662_b(-radius, topHeight   , -radius).func_187315_a(shaftMaxU,shaftMaxV).func_181675_d();
			worldRenderer.func_181662_b(+radius, topHeight   , -radius).func_187315_a(shaftMinU,shaftMaxV).func_181675_d();

			worldRenderer.func_181662_b(-radius, bottomHeight, +radius).func_187315_a(shaftMinU,shaftMinV).func_181675_d();
			worldRenderer.func_181662_b(+radius, bottomHeight, +radius).func_187315_a(shaftMaxU,shaftMinV).func_181675_d();
			worldRenderer.func_181662_b(+radius, topHeight   , +radius).func_187315_a(shaftMaxU,shaftMaxV).func_181675_d();
			worldRenderer.func_181662_b(-radius, topHeight   , +radius).func_187315_a(shaftMinU,shaftMaxV).func_181675_d();

			worldRenderer.func_181662_b(-radius, bottomHeight, -radius).func_187315_a(shaftMinU,shaftMinV).func_181675_d();
			worldRenderer.func_181662_b(-radius, bottomHeight, +radius).func_187315_a(shaftMaxU,shaftMinV).func_181675_d();
			worldRenderer.func_181662_b(-radius, topHeight   , +radius).func_187315_a(shaftMaxU,shaftMaxV).func_181675_d();
			worldRenderer.func_181662_b(-radius, topHeight   , -radius).func_187315_a(shaftMinU,shaftMaxV).func_181675_d();

			worldRenderer.func_181662_b(+radius, bottomHeight, +radius).func_187315_a(shaftMinU,shaftMinV).func_181675_d();
			worldRenderer.func_181662_b(+radius, bottomHeight, -radius).func_187315_a(shaftMaxU,shaftMinV).func_181675_d();
			worldRenderer.func_181662_b(+radius, topHeight   , -radius).func_187315_a(shaftMaxU,shaftMaxV).func_181675_d();
			worldRenderer.func_181662_b(+radius, topHeight   , +radius).func_187315_a(shaftMinU,shaftMaxV).func_181675_d();

			worldRenderer.func_181662_b(-radius, bottomHeight, +radius).func_187315_a(shaftMinU,shaftMinV).func_181675_d();
			worldRenderer.func_181662_b(-radius, bottomHeight, -radius).func_187315_a(shaftMinU+2*pixel,shaftMinV).func_181675_d();
			worldRenderer.func_181662_b(+radius, bottomHeight, -radius).func_187315_a(shaftMinU+2*pixel,shaftMaxV).func_181675_d();
			worldRenderer.func_181662_b(+radius, bottomHeight, +radius).func_187315_a(shaftMinU,shaftMaxV).func_181675_d();
			
			// render axel
			final float axelLength = 4 * pixel;
			final float axelRadius = 1 * pixel;
			final float axelMinU = 0;
			final float axelMaxU = 4 * pixel;
			final float axelMaxU2 = 2 * pixel;
			final float axelMinV = 0.5f;
			final float axelMaxV = 0.5f + 2 * pixel;
			final float axelMaxV2 = 0.5f + 4 * pixel;
			
			worldRenderer.func_181662_b(+axelRadius, -axelRadius, -pixel           ).func_187315_a(axelMinU,axelMinV).func_181675_d();
			worldRenderer.func_181662_b(+axelRadius, -axelRadius, -pixel-axelLength).func_187315_a(axelMaxU,axelMinV).func_181675_d();
			worldRenderer.func_181662_b(+axelRadius, +axelRadius, -pixel-axelLength).func_187315_a(axelMaxU,axelMaxV).func_181675_d();
			worldRenderer.func_181662_b(+axelRadius, +axelRadius, -pixel           ).func_187315_a(axelMinU,axelMaxV).func_181675_d();
			
			worldRenderer.func_181662_b(-axelRadius, +axelRadius, -pixel           ).func_187315_a(axelMinU,axelMinV).func_181675_d();
			worldRenderer.func_181662_b(-axelRadius, +axelRadius, -pixel-axelLength).func_187315_a(axelMaxU,axelMinV).func_181675_d();
			worldRenderer.func_181662_b(-axelRadius, -axelRadius, -pixel-axelLength).func_187315_a(axelMaxU,axelMaxV).func_181675_d();
			worldRenderer.func_181662_b(-axelRadius, -axelRadius, -pixel           ).func_187315_a(axelMinU,axelMaxV).func_181675_d();
			
			worldRenderer.func_181662_b(+axelRadius, +axelRadius, -pixel           ).func_187315_a(axelMinU,axelMaxV2).func_181675_d();
			worldRenderer.func_181662_b(+axelRadius, +axelRadius, -pixel-axelLength).func_187315_a(axelMinU,axelMinV).func_181675_d();
			worldRenderer.func_181662_b(-axelRadius, +axelRadius, -pixel-axelLength).func_187315_a(axelMaxU2,axelMinV).func_181675_d();
			worldRenderer.func_181662_b(-axelRadius, +axelRadius, -pixel           ).func_187315_a(axelMaxU2,axelMaxV2).func_181675_d();
			
			worldRenderer.func_181662_b(-axelRadius, -axelRadius, -pixel           ).func_187315_a(axelMinU,axelMaxV2).func_181675_d();
			worldRenderer.func_181662_b(-axelRadius, -axelRadius, -pixel-axelLength).func_187315_a(axelMinU,axelMinV).func_181675_d();
			worldRenderer.func_181662_b(+axelRadius, -axelRadius, -pixel-axelLength).func_187315_a(axelMaxU2,axelMinV).func_181675_d();
			worldRenderer.func_181662_b(+axelRadius, -axelRadius, -pixel           ).func_187315_a(axelMaxU2,axelMaxV2).func_181675_d();
			
			worldRenderer.func_181662_b(-axelRadius, -axelRadius, -pixel-axelLength).func_187315_a(axelMinU,axelMaxV2).func_181675_d();
			worldRenderer.func_181662_b(-axelRadius, +axelRadius, -pixel-axelLength).func_187315_a(axelMinU,axelMinV).func_181675_d();
			worldRenderer.func_181662_b(+axelRadius, +axelRadius, -pixel-axelLength).func_187315_a(axelMaxU2,axelMinV).func_181675_d();
			worldRenderer.func_181662_b(+axelRadius, -axelRadius, -pixel-axelLength).func_187315_a(axelMaxU2,axelMaxV2).func_181675_d();
			
			// render spinning (or not) blades
			float spin1, spin2, spin3;
			if(e.isSpinning){
				spin1 = e.rotation + HydroturbineEntity.DEGREES_PER_TICK * partialTick;
				spin2 = spin1 + 120;
				spin3 = spin1 - 120;
			} else {
				spin1 = e.rotation;
				spin2 = spin1 + 120;
				spin3 = spin1 - 120;
			}
			final float bladeWidth = 3*pixel;
			final float bladeLength = 6*pixel;
			final float bladeOffset = 1*pixel;
			final float bladeMinU = 0.0f;
			final float bladeMinV = 0.0f;
			final float bladeMaxU = bladeWidth;
			final float bladeMaxV = bladeLength;
			final float depthDelta = pixel;

			final float rotaryWidth = DEGREES_TO_RADIANS*45;
			final float t1 = DEGREES_TO_RADIANS*spin1, t2 = DEGREES_TO_RADIANS*spin2, t3 = DEGREES_TO_RADIANS*spin3;
			final float sin1a = MathHelper.func_76126_a(t1);
			final float sin1b = MathHelper.func_76126_a(t1+rotaryWidth);
			final float cos1a = MathHelper.func_76134_b(t1);
			final float cos1b = MathHelper.func_76134_b(t1+rotaryWidth);
			final float sin2a = MathHelper.func_76126_a(t2);
			final float sin2b = MathHelper.func_76126_a(t2+rotaryWidth);
			final float cos2a = MathHelper.func_76134_b(t2);
			final float cos2b = MathHelper.func_76134_b(t2+rotaryWidth);
			final float sin3a = MathHelper.func_76126_a(t3);
			final float sin3b = MathHelper.func_76126_a(t3+rotaryWidth);
			final float cos3a = MathHelper.func_76134_b(t3);
			final float cos3b = MathHelper.func_76134_b(t3+rotaryWidth);

			worldRenderer.func_181662_b(cos1b*bladeOffset, sin1b*bladeOffset, depthDelta-axelLength).func_187315_a(bladeMinU,bladeMinV).func_181675_d(); // inner, leading
			worldRenderer.func_181662_b(cos1b*bladeLength, sin1b*bladeLength, depthDelta-axelLength).func_187315_a(bladeMinU,bladeMaxV).func_181675_d(); // outer, leading
			worldRenderer.func_181662_b(cos1a*bladeLength, sin1a*bladeLength,           -axelLength).func_187315_a(bladeMaxU,bladeMaxV).func_181675_d(); // outer, trailing
			worldRenderer.func_181662_b(cos1a*bladeOffset, sin1a*bladeOffset,           -axelLength).func_187315_a(bladeMaxU,bladeMinV).func_181675_d(); // inner, trailing

			worldRenderer.func_181662_b(cos1a*bladeOffset, sin1a*bladeOffset,           -axelLength).func_187315_a(bladeMaxU,bladeMinV).func_181675_d(); // inner, trailing
			worldRenderer.func_181662_b(cos1a*bladeLength, sin1a*bladeLength,           -axelLength).func_187315_a(bladeMaxU,bladeMaxV).func_181675_d(); // outer, trailing
			worldRenderer.func_181662_b(cos1b*bladeLength, sin1b*bladeLength, depthDelta-axelLength).func_187315_a(bladeMinU,bladeMaxV).func_181675_d(); // outer, leading
			worldRenderer.func_181662_b(cos1b*bladeOffset, sin1b*bladeOffset, depthDelta-axelLength).func_187315_a(bladeMinU,bladeMinV).func_181675_d(); // inner, leading


			worldRenderer.func_181662_b(cos2b*bladeOffset, sin2b*bladeOffset, depthDelta-axelLength).func_187315_a(bladeMinU,bladeMinV).func_181675_d(); // inner, leading
			worldRenderer.func_181662_b(cos2b*bladeLength, sin2b*bladeLength, depthDelta-axelLength).func_187315_a(bladeMinU,bladeMaxV).func_181675_d(); // outer, leading
			worldRenderer.func_181662_b(cos2a*bladeLength, sin2a*bladeLength,           -axelLength).func_187315_a(bladeMaxU,bladeMaxV).func_181675_d(); // outer, trailing
			worldRenderer.func_181662_b(cos2a*bladeOffset, sin2a*bladeOffset,           -axelLength).func_187315_a(bladeMaxU,bladeMinV).func_181675_d(); // inner, trailing

			worldRenderer.func_181662_b(cos2a*bladeOffset, sin2a*bladeOffset,           -axelLength).func_187315_a(bladeMaxU,bladeMinV).func_181675_d(); // inner, trailing
			worldRenderer.func_181662_b(cos2a*bladeLength, sin2a*bladeLength,           -axelLength).func_187315_a(bladeMaxU,bladeMaxV).func_181675_d(); // outer, trailing
			worldRenderer.func_181662_b(cos2b*bladeLength, sin2b*bladeLength, depthDelta-axelLength).func_187315_a(bladeMinU,bladeMaxV).func_181675_d(); // outer, leading
			worldRenderer.func_181662_b(cos2b*bladeOffset, sin2b*bladeOffset, depthDelta-axelLength).func_187315_a(bladeMinU,bladeMinV).func_181675_d(); // inner, leading


			worldRenderer.func_181662_b(cos3b*bladeOffset, sin3b*bladeOffset, depthDelta-axelLength).func_187315_a(bladeMinU,bladeMinV).func_181675_d(); // inner, leading
			worldRenderer.func_181662_b(cos3b*bladeLength, sin3b*bladeLength, depthDelta-axelLength).func_187315_a(bladeMinU,bladeMaxV).func_181675_d(); // outer, leading
			worldRenderer.func_181662_b(cos3a*bladeLength, sin3a*bladeLength,           -axelLength).func_187315_a(bladeMaxU,bladeMaxV).func_181675_d(); // outer, trailing
			worldRenderer.func_181662_b(cos3a*bladeOffset, sin3a*bladeOffset,           -axelLength).func_187315_a(bladeMaxU,bladeMinV).func_181675_d(); // inner, trailing

			worldRenderer.func_181662_b(cos3a*bladeOffset, sin3a*bladeOffset,           -axelLength).func_187315_a(bladeMaxU,bladeMinV).func_181675_d(); // inner, trailing
			worldRenderer.func_181662_b(cos3a*bladeLength, sin3a*bladeLength,           -axelLength).func_187315_a(bladeMaxU,bladeMaxV).func_181675_d(); // outer, trailing
			worldRenderer.func_181662_b(cos3b*bladeLength, sin3b*bladeLength, depthDelta-axelLength).func_187315_a(bladeMinU,bladeMaxV).func_181675_d(); // outer, leading
			worldRenderer.func_181662_b(cos3b*bladeOffset, sin3b*bladeOffset, depthDelta-axelLength).func_187315_a(bladeMinU,bladeMinV).func_181675_d(); // inner, leading
			
			
			instance.func_78381_a();
			GlStateManager.func_179101_C();
			GlStateManager.func_179121_F();
			super.func_76986_a(e, x, y, z, scale, partialTick);
		}
	}


	@Override
	protected ResourceLocation func_110775_a(final Entity e) {
		return texture;
	}
}
