package cyano.electricadvantage.machines;

import cyano.electricadvantage.init.Power;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.FurnaceRecipes;
import net.minecraft.nbt.NBTTagCompound;

public class ElectricOvenTileEntity extends ElectricMachineTileEntity{


	public static final float ENERGY_PER_TICK = 4f;
	private final short totalCookTime = 100;
	private short progress = 0;
	
	public ElectricOvenTileEntity() {
		super(ElectricOvenTileEntity.class.getName(), 1, 1, 0);
	}

	@Override
	public void tickUpdate(boolean isServerWorld) {
		if(isServerWorld){
			boolean active = false;
			if(getInputSlot(0) == null || hasRedstoneSignal()){
				progress = 0;
			} else if(getEnergy() >= ENERGY_PER_TICK){
				ItemStack output = FurnaceRecipes.func_77602_a().func_151395_a(getInputSlot(0));
				if(isFoodItem(output) && hasSpaceForItemInOutputSlots(output)){
					subtractEnergy(ENERGY_PER_TICK,Power.ELECTRIC_POWER);
					progress++;
					if(progress >= totalCookTime){
						this.insertItemToOutputSlots(output.func_77946_l());
						getInputSlot(0).field_77994_a--;
						if(getInputSlot(0).field_77994_a <= 0){
							setInputSlot(0,null);
						}
						progress = 0;
						playSoundEffect(func_174877_v().func_177958_n()+0.5, func_174877_v().func_177956_o()+0.5, func_174877_v().func_177952_p()+0.5, SoundEvents.field_187604_bf, 0.5f, 1.0f);
					}
					active = true;
				} else {
					progress = 0;
				}
			} else {
				if(progress > 0) progress--;
			}
			this.setActiveState(active);
		}
		
	}
	
	public static boolean isFoodItem(ItemStack item){
		if(item == null) return false;
		Item i = item.func_77973_b();
		return (i instanceof net.minecraft.item.ItemFood);
	}
	
	public static boolean becomesFoodItem(ItemStack item){
		if(item == null) return false;
		return isFoodItem(FurnaceRecipes.func_77602_a().func_151395_a(item));
		
	}
	
	
	@Override
	public boolean isPowered() {
		return getEnergy() > ENERGY_PER_TICK;
	}

	private final float[] progs = new float[1];
	@Override
	public float[] getProgress() {
		progs[0] = (float)progress / (float)totalCookTime;
		return progs;
	}

	@Override
	protected void saveTo(NBTTagCompound tagRoot) {
		tagRoot.func_74777_a("cookTime", progress);
	}

	@Override
	protected void loadFrom(NBTTagCompound tagRoot) {
		if(tagRoot.func_74764_b("cookTime")){
			progress = tagRoot.func_74765_d("cookTime");
		}
	}

	@Override
	protected boolean isValidInputItem(ItemStack item) {
		return becomesFoodItem(item);
	}

	final int[] dataArray = new int[2];
	@Override
	public int[] getDataFieldArray() {
		return dataArray;
	}

	@Override
	public void onDataFieldUpdate() {
		setEnergy(Float.intBitsToFloat(dataArray[0]),getType());
		progress = (short)dataArray[1];
	}

	@Override
	public void prepareDataFieldsForSync() {
		dataArray[0] = Float.floatToIntBits(getEnergy());
		dataArray[1] = progress;
	}


}
