package cyano.electricadvantage.machines;

import cyano.electricadvantage.entities.HydroturbineEntity;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.math.AxisAlignedBB;

import java.util.List;
import java.util.Random;

public class HydroelectricGeneratorTileEntity extends ElectricGeneratorTileEntity {

	
	public static final float ENERGY_PER_TICK = 4;
	
	private static final long checkInterval = 101;
	private static final Random initRand = new Random();
	private final long checkOffset = initRand.nextInt((int)checkInterval);
	
	private boolean isInitialized;
	
	public HydroelectricGeneratorTileEntity() {
		super(HydroelectricGeneratorTileEntity.class.getName(), 0);
		isInitialized = false;
	}

	@Override
	public void tickUpdate(boolean isServer) {
		if(isServer){
			if(!isInitialized){
				initialize();
			}
			if((func_145831_w().func_82737_E() + checkOffset) % checkInterval == 0){
				// periodically check if the hydroturbine entity is still present
				List turbines = func_145831_w().func_72872_a(HydroturbineEntity.class, new AxisAlignedBB(
						func_174877_v().func_177958_n(),func_174877_v().func_177956_o()-1,func_174877_v().func_177952_p(),
						func_174877_v().func_177958_n()+1,func_174877_v().func_177956_o(),func_174877_v().func_177952_p()+1));
				if(turbines == null || turbines.isEmpty()){
					// turbine entity got deleted
					initialize();
				}
			}
		}
	}
	
	private void initialize() {
		isInitialized = true;
		if(func_174877_v().func_177956_o() > 0){
			func_145831_w().func_72838_d(new HydroturbineEntity(func_145831_w(),this));
		}
	}

	@Override
	public float getPowerOutput() {
		if(this.isActive()){
			return 15;
		} else {
			return 0;
		}
	}

	@Override
	protected boolean isValidInputItem(ItemStack item) {
		return false;
	}

	@Override
	protected void saveTo(NBTTagCompound tagRoot) {
		tagRoot.func_74757_a("initDone", this.isInitialized);
	}

	@Override
	protected void loadFrom(NBTTagCompound tagRoot) {
		if(tagRoot.func_74764_b("initDone")){
			this.isInitialized = tagRoot.func_74767_n("initDone");
		}
	}

	final int[] dataArray = new int[1];
	@Override
	public int[] getDataFieldArray() {
		return dataArray;
	}

	@Override
	public void onDataFieldUpdate() {
		this.setEnergy(Float.intBitsToFloat(dataArray[0]), getType());
	}

	@Override
	public void prepareDataFieldsForSync() {
		dataArray[0] = Float.floatToIntBits(getEnergy());
	}

	@Override
	public void setActive(boolean active){
		// make public
		super.setActive(active);
	}
}
