package cyano.electricadvantage.machines;

import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

import java.util.List;

public class LaserTurretBlock extends ElectricMachineBlock {

	private final AxisAlignedBB baseBounds = new AxisAlignedBB(0.0f, 0.0f, 0.0f, 1.0f, 0.25f, 1.0f);
	private final AxisAlignedBB shaftBounds = new AxisAlignedBB(0.25f, 0.25f, 0.25f, 0.75f, 1.0f, 0.75f);

	// Evil laser turrets target players and not hostile mobs
	public final boolean evil;
	public LaserTurretBlock(boolean isEvil) {
		super();
		this.func_149711_c(5.0F).func_149752_b(100.0F);
		this.evil = isEvil;
	}

	@Override
	public ElectricMachineTileEntity func_149915_a(World arg0, int arg1) {
		return new LaserTurretTileEntity();
	}




	@Override
	public AxisAlignedBB func_185496_a(final IBlockState bs, final IBlockAccess world, final BlockPos coord) {
		return baseBounds;
	}
	@Override
	public void func_185477_a(final IBlockState bs, final World world, final BlockPos coord,
									  final AxisAlignedBB box, final List<AxisAlignedBB> collisionBoxList,
									  final Entity entity) {

		final EnumFacing orientation = (EnumFacing) world.func_180495_p(coord).func_177229_b(FACING);
		super.func_185492_a(coord, box, collisionBoxList, baseBounds);
		super.func_185492_a(coord, box, collisionBoxList, shaftBounds);
	}
	
	@Override
	public void func_180633_a(World w, BlockPos pos, IBlockState state, EntityLivingBase placer, ItemStack stack) {
		super.func_180633_a(w, pos, state, placer, stack);
		TileEntity te = w.func_175625_s(pos);
		if(placer instanceof EntityPlayer && te instanceof LaserTurretTileEntity){
			((LaserTurretTileEntity)te).setOwner((EntityPlayer)placer);
		}
	}

}
