package cyano.electricadvantage.machines;

import cyano.electricadvantage.init.Power;
import cyano.poweradvantage.api.ConduitType;
import cyano.poweradvantage.api.PowerConnectorContext;
import cyano.poweradvantage.conduitnetwork.ConduitRegistry;
import cyano.poweradvantage.init.Fluids;
import net.minecraft.block.state.IBlockState;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.Explosion;
import net.minecraft.world.World;

public class PlasticRefineryBlock extends ElectricMachineBlock{

	@Override
	public ElectricMachineTileEntity func_149915_a(World w, int m) {
		return new PlasticRefineryTileEntity();
	}
	
///// Overrides to make this a multi-type block /////
	
	/**
	 * This method is called whenever the block is placed into the world
	 */
	@Override
	public void func_176213_c(World w, BlockPos coord, IBlockState state){
		super.func_176213_c(w, coord, state);
		ConduitRegistry.getInstance().conduitBlockPlacedEvent(w, w.field_73011_w.getDimension(), coord, cyano.poweradvantage.init.Fluids.fluidConduit_general);
	}
	
	/**
	 * This method is called when the block is removed from the world by an entity.
	 */
	@Override
	public void func_176206_d(World w, BlockPos coord, IBlockState state){
		super.func_176206_d(w, coord, state);
		ConduitRegistry.getInstance().conduitBlockPlacedEvent(w, w.field_73011_w.getDimension(), coord, cyano.poweradvantage.init.Fluids.fluidConduit_general);
	}
	/**
	 * This method is called when the block is destroyed by an explosion.
	 */
	@Override
	public void func_180652_a(World w, BlockPos coord, Explosion boom){
		super.func_180652_a(w, coord, boom);
		ConduitRegistry.getInstance().conduitBlockPlacedEvent(w, w.field_73011_w.getDimension(), coord, Fluids.fluidConduit_general);
	}


	@Override
	public boolean isPowerSource(ConduitType e){
		return false;
	}
	@Override
	public boolean isPowerSink(ConduitType e){
		return true;
	}
	private final ConduitType[] types = {Power.ELECTRIC_POWER,Fluids.fluidConduit_general};
	@Override
	public ConduitType[] getTypes(){
		return types;
	}
	@Override
	public boolean canAcceptConnection(PowerConnectorContext c){
		return ConduitType.areSameType(Power.ELECTRIC_POWER,c.powerType)
				|| Fluids.isFluidType(c.powerType);
	}
	///// end multi-type overrides /////

}
